﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private sv1 As ScrollView
	Private cal As calendar
	Public notedialog As B4XDialog
	Private edt1 As EditText
	Public folder As String
	Public rp As RuntimePermissions
	Public seq As Int = 2	' 1 = mo - su, 2 = su - sa
	Private cbxendday As B4XComboBox
	Private cbxendmonth As B4XComboBox
	Private cbxendyear As B4XComboBox
	Private cbxstartday As B4XComboBox
	Private cbxstartmonth As B4XComboBox
	Private cbxstartyear As B4XComboBox
	Private btnshow As Button
	Private yyyylst As List
	Private mmlst As List
	Private ddlst As List
	Public currentyear As Int
	Public startyear As Int = 0
	Public startmonth As Int
	Public startday As Int
	Public endyear As Int
	Public endmonth As Int
	Public endday As Int
	Public pnlperiods As Panel
End Sub
Public Sub Initialize
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Calendar_with_periods")
	notedialog.Initialize(Root)
	notedialog.PutAtTop = True
	notedialog.BackgroundColor = Colors.LightGray
	notedialog.BodyTextColor = Colors.Blue
	menuitem_toevoegen(Me, "Today")
	menuitem_toevoegen(Me, "Monday-Sunday")
	menuitem_toevoegen(Me, "Sunday-Saturday")
	menuitem_toevoegen(Me, "Periods")
	menuitem_toevoegen(Me, "Reset")
	folder = rp.GetSafeDirDefaultExternal("")
	yyyylst.Initialize
	mmlst.Initialize
	ddlst.Initialize
	currentyear = DateTime.GetYear(DateTime.Now)
	For i = (currentyear -3) To (currentyear + 3)
		yyyylst.Add(i)
	Next
	Log(yyyylst)
	cbxstartyear.SetItems(yyyylst)
	cbxendyear.SetItems(yyyylst)
	For i = 1 To 12
		mmlst.Add(i)
	Next
	cbxstartmonth.SetItems(mmlst)
	cbxendmonth.SetItems(mmlst)
	For i = 1 To 31					' no test on the month selected yet
		ddlst.Add(i)
	Next
	cbxstartday.SetItems(ddlst)
	cbxendday.SetItems(ddlst)
	show_calendar
End Sub
Private Sub B4XPage_Appear
End Sub
Private Sub B4XPage_Disappear
	sv1.Panel.RemoveAllViews
End Sub
Private Sub menuitem_toevoegen(objpage As Object, itemname As String)
	Private mnuitem As B4AMenuItem = B4XPages.AddMenuItem(objpage,itemname)
	mnuitem.AddToBar = True
End Sub
Sub B4XPage_MenuClick (Tag As String)
	If Tag = "Today" Then
		show_calendar
	End If
	If Tag = "Monday-Sunday" Then
		seq = 1
		show_calendar
	End If
	If Tag = "Sunday-Saturday" Then
		seq = 2
		show_calendar
	End If
	If Tag = "Periods" Then
		show_calendar
	End If
	If Tag = "Reset" Then
		startyear = 0
		cbxstartyear.SelectedIndex = 0
		cbxstartmonth.SelectedIndex = 0
		cbxstartday.SelectedIndex = 0
		cbxendyear.SelectedIndex = 0
		cbxendmonth.SelectedIndex = 0
		cbxendday.SelectedIndex = 0
		show_calendar
	End If
End Sub
Private Sub show_calendar
	If startyear = 0 Then
		startyear = currentyear
		startmonth = 1
		startday = 1
		endyear = currentyear
		endmonth = 12
		endday = 31
	Else
		startyear = cbxstartyear.SelectedItem
		startmonth = cbxstartmonth.SelectedItem
		startday = cbxstartday.SelectedItem
		endyear = cbxendyear.SelectedItem
		endmonth = cbxendmonth.SelectedItem
		endday = cbxendday.SelectedItem
	End If

	sv1.Panel.RemoveAllViews
	cal.Initialize(Me,"cal")
	Private pnl As Panel
	pnl.Initialize("pnl")
	Dim toppos As Int = 1dip
	Dim monthcnt As Int = 1
	Dim monthslst As List
	monthslst.Initialize
	If startyear = endyear Then
		For m = 1 To 12
			If m >= startmonth And m <= endmonth Then monthslst.Add(startyear & "|" & m)
		Next
	End If
	If startyear <> endyear Then
		For y = startyear To endyear
			For m = 1 To 12
				If y = endyear Then
					If m <= endmonth Then monthslst.Add(y & "|" & m)
				Else
					If y = startyear Then
						If m >= startmonth Then monthslst.Add(y & "|" & m)
					Else
						monthslst.Add(y & "|" & m)
					End If
				End If
			Next
		Next
	End If
	Log(monthslst)
	For i = 0 To monthslst.Size -1
		Dim yearmonth As String = monthslst.Get(i)
		Dim yy As Int = yearmonth.SubString2(0,yearmonth.IndexOf("|"))
		Dim mm As Int = yearmonth.SubString(yearmonth.IndexOf("|")+1)
		pnl = cal.set_month_panel(mm,yy,seq,startyear,startmonth,startday,endyear,endmonth,endday)	' sequence 1 = mo - su, 2 = su - sa
		If monthcnt = 1 Then
			sv1.panel.AddView(pnl,1dip,toppos,pnl.Width,pnl.Height)
		Else
			sv1.panel.AddView(pnl,1dip,(pnl.Height*(monthcnt-1)),pnl.Width,pnl.Height)
		End If
		monthcnt = monthcnt + 1
	Next
	sv1.panel.Width = pnl.Width
	sv1.Panel.Height = (pnl.Height * monthslst.size)
	Private pos As Int = 1dip
	sv1.ScrollToNow(pos)
End Sub
Public Sub cal_dayclick
	Private dayticks As Long = cal.lblticks
	Private year As Int = DateTime.GetYear(dayticks)
	Private month As Int = DateTime.GetMonth(dayticks)
	Private day As Int = DateTime.GetDayOfMonth(dayticks)
	Private lst As List
	lst.Initialize
	lst = Array As String("January","February","March","April","May","June","July","August","September","October","November","December")
	DateTime.DateFormat = "dd/MM/yyyy"
	Private strdate  As String = day & " " & lst.Get(month-1) & " " & year
	Private note As String = load_note(dayticks)
	If note = "" Then
		show_add_dialog(strdate)
	Else
		show_change_dialog(note,strdate)	
	End If
End Sub
Sub load_note(ticks As String) As String
	If File.Exists(folder,ticks & "_notes.txt") Then
		Return File.ReadString(folder,ticks & "_notes.txt")
	Else
		Return ""
	End If
End Sub
Sub save_note(ticks As String,note As String)
	File.Delete(folder,ticks & "_notes.txt")
	File.WriteString(folder,ticks & "_notes.txt",note)
End Sub
Private Sub show_add_dialog(strdate As String)
	edt1.Initialize("")
	Dim pnl1 As Panel = setup_dialog("note_dialog",strdate)
	Wait For (notedialog.ShowCustom(pnl1, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If edt1.Text <> "" Then
			save_note(cal.lblticks,edt1.Text)
			sv1.Panel.RemoveAllViews
			show_calendar
		End If
	End If
End Sub
Private Sub show_change_dialog(note As String, strdate As String)
	Dim pnl1 As Panel = setup_dialog("note_dialog",strdate)
	Dim rs1 As ResumableSub =  notedialog.ShowCustom(pnl1, "SAVE", "DELETE", "CANCEL")
	edt1.Text = note
	Wait For (rs1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If edt1.Text <> "" Then
			save_note(cal.lblticks,edt1.Text)
		End If
	else if Result = xui.dialogResponse_Negative Then
		File.Delete(folder,cal.lblticks & "_notes.txt")
		sv1.Panel.RemoveAllViews
		show_calendar
	End If
End Sub
private Sub setup_dialog(strlayout As String,lbltext As String) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 300dip, 190dip)
	pnl.LoadLayout(strlayout)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Gravity = Bit.Or(Gravity.LEFT,Gravity.TOP)
	lbl.Text = lbltext
	lbl.TextSize = 18
	lbl.TextColor = Colors.Black
	lbl.Color = Colors.ARGB(100,182,221,249)
	pnl.AddView(lbl,0,0,340dip,50dip)
	Return pnl
End Sub

Private Sub cbxstartyear_SelectedIndexChanged (Index As Int)
	startyear = cbxstartyear.SelectedItem
End Sub

Private Sub cbxstartmonth_SelectedIndexChanged (Index As Int)
	startmonth = cbxstartmonth.SelectedItem
End Sub

Private Sub cbxstartday_SelectedIndexChanged (Index As Int)
	startday = cbxstartday.SelectedItem
End Sub

Private Sub cbxendyear_SelectedIndexChanged (Index As Int)
	endyear = cbxendyear.SelectedItem
End Sub

Private Sub cbxendmonth_SelectedIndexChanged (Index As Int)
	endmonth = cbxendmonth.SelectedItem
End Sub

Private Sub cbxendday_SelectedIndexChanged (Index As Int)
	endday = cbxendday.SelectedItem
End Sub

Private Sub btnshow_Click
	show_calendar
End Sub